module DirectX9.D3D.Constant
where
import DirectX9.Types

#include "windows.h"
#include "fix_decl.h"
#include "d3d9.h"


type D3DCAPS2 = DWORD
#{enum D3DCAPS2,
    , d3DCAPS2_CANAUTOGENMIPMAP     = D3DCAPS2_CANAUTOGENMIPMAP
    , d3DCAPS2_CANCALIBRATEGAMMA    = D3DCAPS2_CANCALIBRATEGAMMA
    , d3DCAPS2_CANMANAGERESOURCE    = D3DCAPS2_CANMANAGERESOURCE
    , d3DCAPS2_DYNAMICTEXTURES      = D3DCAPS2_DYNAMICTEXTURES
    , d3DCAPS2_FULLSCREENGAMMA      = D3DCAPS2_FULLSCREENGAMMA
    , d3DCAPS2_RESERVED             = D3DCAPS2_RESERVED
    }

type D3DCAPS3 = DWORD
#{enum D3DCAPS3,
    , d3DCAPS3_ALPHA_FULLSCREEN_FLIP_OR_DISCARD     = D3DCAPS3_ALPHA_FULLSCREEN_FLIP_OR_DISCARD
    , d3DCAPS3_COPY_TO_VIDMEM                       = D3DCAPS3_COPY_TO_VIDMEM
    , d3DCAPS3_COPY_TO_SYSTEMMEM                    = D3DCAPS3_COPY_TO_SYSTEMMEM
    , d3DCAPS3_LINEAR_TO_SRGB_PresentATION          = D3DCAPS3_LINEAR_TO_SRGB_PRESENTATION
    , d3DCAPS3_RESERVED                             = D3DCAPS3_RESERVED
    }

type D3DCLEAR = DWORD
#{enum D3DCLEAR,
    , d3DCLEAR_STENCIL  = D3DCLEAR_STENCIL
    , d3DCLEAR_TARGET   = D3DCLEAR_TARGET
    , d3DCLEAR_ZBUFFER  = D3DCLEAR_ZBUFFER
    }

type D3DCREATE = DWORD
#{enum D3DCREATE,
    , d3DCREATE_FPU_PRESERVE                    = D3DCREATE_FPU_PRESERVE
    , d3DCREATE_HARDWARE_VERTEXPROCESSING       = D3DCREATE_HARDWARE_VERTEXPROCESSING
    , d3DCREATE_MIXED_VERTEXPROCESSING          = D3DCREATE_MIXED_VERTEXPROCESSING
    , d3DCREATE_MULTITHREADED                   = D3DCREATE_MULTITHREADED
    , d3DCREATE_PUREDEVICE                      = D3DCREATE_PUREDEVICE
    , d3DCREATE_SOFTWARE_VERTEXPROCESSING       = D3DCREATE_SOFTWARE_VERTEXPROCESSING
    }
    -- , d3DCREATE_ADAPTERGROUP_DEVICE             = D3DCREATE_ADAPTERGROUP_DEVICE
    -- , d3DCREATE_DISABLE_DRIVER_MANAGEMENT       = D3DCREATE_DISABLE_DRIVER_MANAGEMENT
    -- , d3DCREATE_DISABLE_DRIVER_MANAGEMENT_EX    = D3DCREATE_DISABLE_DRIVER_MANAGEMENT_EX
    -- , d3DCREATE_NOWINDOWCHANGES                 = D3DCREATE_NOWINDOWCHANGES

type D3DCURSORCAPS_COLOR = DWORD
#{enum D3DCURSORCAPS_COLOR,
    , d3DCURSORCAPS_COLOR   = D3DCURSORCAPS_COLOR
    , d3DCURSORCAPS_LOWRES  = D3DCURSORCAPS_LOWRES
    }

type D3DDEVCAPS2 = DWORD
#{enum D3DDEVCAPS2,
    , d3DDEVCAPS2_ADAPTIVETESSRTPATCH                   = D3DDEVCAPS2_ADAPTIVETESSRTPATCH
    , d3DDEVCAPS2_ADAPTIVETESSNPATCH                    = D3DDEVCAPS2_ADAPTIVETESSNPATCH
    , d3DDEVCAPS2_CAN_STRETCHRECT_FROM_TEXTURES         = D3DDEVCAPS2_CAN_STRETCHRECT_FROM_TEXTURES
    , d3DDEVCAPS2_DMAPNPATCH                            = D3DDEVCAPS2_DMAPNPATCH
    , d3DDEVCAPS2_PRESAMPLEDDMAPNPATCH                  = D3DDEVCAPS2_PRESAMPLEDDMAPNPATCH
    , d3DDEVCAPS2_STREAMOFFSET                          = D3DDEVCAPS2_STREAMOFFSET
    , d3DDEVCAPS2_VERTEXELEMENTSCANSHARESTREAMOFFSET    = D3DDEVCAPS2_VERTEXELEMENTSCANSHARESTREAMOFFSET
    }

type D3DDTCAPS = DWORD
#{enum D3DDTCAPS,
    , d3DDTCAPS_UBYTE4      = D3DDTCAPS_UBYTE4
    , d3DDTCAPS_UBYTE4N     = D3DDTCAPS_UBYTE4N
    , d3DDTCAPS_SHORT2N     = D3DDTCAPS_SHORT2N
    , d3DDTCAPS_SHORT4N     = D3DDTCAPS_SHORT4N
    , d3DDTCAPS_USHORT2N    = D3DDTCAPS_USHORT2N
    , d3DDTCAPS_USHORT4N    = D3DDTCAPS_USHORT4N
    , d3DDTCAPS_UDEC3       = D3DDTCAPS_UDEC3
    , d3DDTCAPS_DEC3N       = D3DDTCAPS_DEC3N
    , d3DDTCAPS_FLOAT16_2   = D3DDTCAPS_FLOAT16_2
    , d3DDTCAPS_FLOAT16_4   = D3DDTCAPS_FLOAT16_4
    }

type D3DFVF = DWORD
#{enum D3DFVF,
    , d3DFVF_DIFFUSE             = D3DFVF_DIFFUSE
    , d3DFVF_NORMAL              = D3DFVF_NORMAL
    , d3DFVF_PSIZE               = D3DFVF_PSIZE
    , d3DFVF_SPECULAR            = D3DFVF_SPECULAR
    , d3DFVF_XYZ                 = D3DFVF_XYZ
    , d3DFVF_XYZRHW              = D3DFVF_XYZRHW
    , d3DFVF_XYZB1               = D3DFVF_XYZB1
    , d3DFVF_XYZB2               = D3DFVF_XYZB2
    , d3DFVF_XYZB3               = D3DFVF_XYZB3
    , d3DFVF_XYZB4               = D3DFVF_XYZB4
    , d3DFVF_XYZB5               = D3DFVF_XYZB5
    , d3DFVF_XYZW                = D3DFVF_XYZW
    , d3DFVF_TEX1                = D3DFVF_TEX1
    , d3DFVF_TEX2                = D3DFVF_TEX2
    , d3DFVF_TEX3                = D3DFVF_TEX3
    , d3DFVF_TEX4                = D3DFVF_TEX4
    , d3DFVF_TEX5                = D3DFVF_TEX5
    , d3DFVF_TEX6                = D3DFVF_TEX6
    , d3DFVF_TEX7                = D3DFVF_TEX7
    , d3DFVF_TEX8                = D3DFVF_TEX8
    , d3DFVF_POSITION_MASK       = D3DFVF_POSITION_MASK
    , d3DFVF_TEXCOUNT_MASK       = D3DFVF_TEXCOUNT_MASK
    , d3DFVF_LASTBETA_D3DCOLOR   = D3DFVF_LASTBETA_D3DCOLOR
    , d3DFVF_LASTBETA_UBYTE4     = D3DFVF_LASTBETA_UBYTE4
    , d3DFVF_TEXCOUNT_SHIFT      = D3DFVF_TEXCOUNT_SHIFT
    }

type D3DLOCK = DWORD
#{enum D3DLOCK,
    , d3DLOCK_DISCARD                   = D3DLOCK_DISCARD
    , d3DLOCK_NO_DIRTY_UPDATE           = D3DLOCK_NO_DIRTY_UPDATE
    , d3DLOCK_NOOVERWRITE               = D3DLOCK_NOOVERWRITE
    , d3DLOCK_NOSYSLOCKD3DLOCK_READONLY = D3DLOCK_NOSYSLOCK
    , d3DLOCK_READONLY                  = D3DLOCK_READONLY
    }
    -- , d3DLOCK_DONOTWAIT                 = D3DLOCK_DONOTWAIT

type D3DPMISCCAPS = DWORD
#{enum D3DPMISCCAPS,
    , d3DPMISCCAPS_MASKZ                        = D3DPMISCCAPS_MASKZ
    , d3DPMISCCAPS_CULLNONE                     = D3DPMISCCAPS_CULLNONE
    , d3DPMISCCAPS_CULLCW                       = D3DPMISCCAPS_CULLCW
    , d3DPMISCCAPS_CULLCCW                      = D3DPMISCCAPS_CULLCCW
    , d3DPMISCCAPS_COLORWRITEENABLE             = D3DPMISCCAPS_COLORWRITEENABLE
    , d3DPMISCCAPS_CLIPPLANESCALEDPOINTS        = D3DPMISCCAPS_CLIPPLANESCALEDPOINTS
    , d3DPMISCCAPS_CLIPTLVERTS                  = D3DPMISCCAPS_CLIPTLVERTS
    , d3DPMISCCAPS_TSSARGTEMP                   = D3DPMISCCAPS_TSSARGTEMP
    , d3DPMISCCAPS_BLENDOP                      = D3DPMISCCAPS_BLENDOP
    , d3DPMISCCAPS_NULLREFERENCE                = D3DPMISCCAPS_NULLREFERENCE
    , d3DPMISCCAPS_INDEPENDENTWRITEMASKS        = D3DPMISCCAPS_INDEPENDENTWRITEMASKS
    , d3DPMISCCAPS_PERSTAGECONSTANT             = D3DPMISCCAPS_PERSTAGECONSTANT
    , d3DPMISCCAPS_FOGANDSPECULARALPHA          = D3DPMISCCAPS_FOGANDSPECULARALPHA
    , d3DPMISCCAPS_SEPARATEALPHABLEND           = D3DPMISCCAPS_SEPARATEALPHABLEND
    , d3DPMISCCAPS_MRTINDEPENDENTBITDEPTHS      = D3DPMISCCAPS_MRTINDEPENDENTBITDEPTHS
    , d3DPMISCCAPS_MRTPOSTPIXELSHADERBLENDING   = D3DPMISCCAPS_MRTPOSTPIXELSHADERBLENDING
    , d3DPMISCCAPS_FOGVERTEXCLAMPED             = D3DPMISCCAPS_FOGVERTEXCLAMPED
    }


type D3DPRESENT = DWORD
#{enum D3DPRESENT,
    , d3DPRESENT_INTERVAL_DEFAULT       = D3DPRESENT_INTERVAL_DEFAULT 
    , d3DPRESENT_INTERVAL_ONE           = D3DPRESENT_INTERVAL_ONE 
    , d3DPRESENT_INTERVAL_TWO           = D3DPRESENT_INTERVAL_TWO 
    , d3DPRESENT_INTERVAL_THREE         = D3DPRESENT_INTERVAL_THREE 
    , d3DPRESENT_INTERVAL_FOUR          = D3DPRESENT_INTERVAL_FOUR 
    , d3DPRESENT_INTERVAL_IMMEDIATE     = D3DPRESENT_INTERVAL_IMMEDIATE 
    }
    -- , d3DPRESENT_DONOTWAIT              = D3DPRESENT_DONOTWAIT 
    -- , d3DPRESENT_LINEAR_CONTENT         = D3DPRESENT_LINEAR_CONTENT 

type D3DPRESENTFLAG = DWORD
#{enum D3DPRESENTFLAG,
    , d3DPRESENTFLAG_DEVICECLIP             = D3DPRESENTFLAG_DEVICECLIP
    , d3DPRESENTFLAG_DISCARD_DEPTHSTENCIL   = D3DPRESENTFLAG_DISCARD_DEPTHSTENCIL
    , d3DPRESENTFLAG_LOCKABLE_BACKBUFFER    = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER
    , d3DPRESENTFLAG_VIDEO                  = D3DPRESENTFLAG_VIDEO
    }

    -- , d3DD3DPSHADERCAPS2_0_ARBITRARYSWIZZLE         = D3DD3DPSHADERCAPS2_0_ARBITRARYSWIZZLE
    -- , d3DD3DPSHADERCAPS2_0_GRADIENTINSTRUCTIONS     = D3DD3DPSHADERCAPS2_0_GRADIENTINSTRUCTIONS
    -- , d3DD3DPSHADERCAPS2_0_PREDICATION              = D3DD3DPSHADERCAPS2_0_PREDICATION
    -- , d3DD3DPSHADERCAPS2_0_NODEPENDENTREADLIMIT     = D3DD3DPSHADERCAPS2_0_NODEPENDENTREADLIMIT
    -- , d3DD3DPSHADERCAPS2_0_NOTEXINSTRUCTIONLIMIT    = D3DD3DPSHADERCAPS2_0_NOTEXINSTRUCTIONLIMIT
type D3DD3DPSHADERCAPS2 = DWORD
#{enum D3DD3DPSHADERCAPS2, 
    , d3DPS20_MAX_DYNAMICFLOWCONTROLDEPTH           = D3DPS20_MAX_DYNAMICFLOWCONTROLDEPTH
    , d3DPS20_MIN_DYNAMICFLOWCONTROLDEPTH           = D3DPS20_MIN_DYNAMICFLOWCONTROLDEPTH
    , d3DPS20_MAX_NUMTEMPS                          = D3DPS20_MAX_NUMTEMPS
    , d3DPS20_MIN_NUMTEMPS                          = D3DPS20_MIN_NUMTEMPS
    , d3DPS20_MAX_STATICFLOWCONTROLDEPTH            = D3DPS20_MAX_STATICFLOWCONTROLDEPTH
    , d3DPS20_MIN_STATICFLOWCONTROLDEPTH            = D3DPS20_MIN_STATICFLOWCONTROLDEPTH
    , d3DPS20_MAX_NUMINSTRUCTIONSLOTS               = D3DPS20_MAX_NUMINSTRUCTIONSLOTS
    , d3DPS20_MIN_NUMINSTRUCTIONSLOTS               = D3DPS20_MIN_NUMINSTRUCTIONSLOTS
    }

type D3DPTFILTERCAPS = DWORD
#{enum D3DPTFILTERCAPS,
    , d3DPTFILTERCAPS_MAGFPOINT             = D3DPTFILTERCAPS_MAGFPOINT
    , d3DPTFILTERCAPS_MAGFLINEAR            = D3DPTFILTERCAPS_MAGFLINEAR
    , d3DPTFILTERCAPS_MAGFANISOTROPIC       = D3DPTFILTERCAPS_MAGFANISOTROPIC
    , d3DPTFILTERCAPS_MAGFPYRAMIDALQUAD     = D3DPTFILTERCAPS_MAGFPYRAMIDALQUAD
    , d3DPTFILTERCAPS_MAGFGAUSSIANQUAD      = D3DPTFILTERCAPS_MAGFGAUSSIANQUAD
    , d3DPTFILTERCAPS_MINFPOINT             = D3DPTFILTERCAPS_MINFPOINT
    , d3DPTFILTERCAPS_MINFLINEAR            = D3DPTFILTERCAPS_MINFLINEAR
    , d3DPTFILTERCAPS_MINFANISOTROPIC       = D3DPTFILTERCAPS_MINFANISOTROPIC
    , d3DPTFILTERCAPS_MINFPYRAMIDALQUAD     = D3DPTFILTERCAPS_MINFPYRAMIDALQUAD
    , d3DPTFILTERCAPS_MINFGAUSSIANQUAD      = D3DPTFILTERCAPS_MINFGAUSSIANQUAD
    , d3DPTFILTERCAPS_MIPFPOINT             = D3DPTFILTERCAPS_MIPFPOINT
    , d3DPTFILTERCAPS_MIPFLINEAR            = D3DPTFILTERCAPS_MIPFLINEAR
    }

type D3DSTENCILCAPS = DWORD
#{enum D3DSTENCILCAPS,
    , d3DSTENCILCAPS_KEEP       = D3DSTENCILCAPS_KEEP
    , d3DSTENCILCAPS_ZERO       = D3DSTENCILCAPS_ZERO
    , d3DSTENCILCAPS_REPLACE    = D3DSTENCILCAPS_REPLACE
    , d3DSTENCILCAPS_INCRSAT    = D3DSTENCILCAPS_INCRSAT
    , d3DSTENCILCAPS_DECRSAT    = D3DSTENCILCAPS_DECRSAT
    , d3DSTENCILCAPS_INVERT     = D3DSTENCILCAPS_INVERT
    , d3DSTENCILCAPS_INCR       = D3DSTENCILCAPS_INCR
    , d3DSTENCILCAPS_DECR       = D3DSTENCILCAPS_DECR
    , d3DSTENCILCAPS_TWOSIDED   = D3DSTENCILCAPS_TWOSIDED
    }

type D3DTA = DWORD
#{enum D3DTA,
    , d3DTA_CONSTANT    = D3DTA_CONSTANT
    , d3DTA_CURRENT     = D3DTA_CURRENT
    , d3DTA_DIFFUSE     = D3DTA_DIFFUSE
    , d3DTA_SELECTMASK  = D3DTA_SELECTMASK
    , d3DTA_SPECULAR    = D3DTA_SPECULAR
    , d3DTA_TEMP        = D3DTA_TEMP
    , d3DTA_TEXTURE     = D3DTA_TEXTURE
    , d3DTA_TFACTOR     = D3DTA_TFACTOR
    }
    
type D3DTSS_TCI = DWORD
#{enum D3DTSS_TCI,
    , d3DTSS_TCI_PASSTHRU                   = D3DTSS_TCI_PASSTHRU
    , d3DTSS_TCI_CAMERASPACENORMAL          = D3DTSS_TCI_CAMERASPACENORMAL
    , d3DTSS_TCI_CAMERASPACEPOSITION        = D3DTSS_TCI_CAMERASPACEPOSITION
    , d3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR= D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR
    , d3DTSS_TCI_SPHEREMAP                  = D3DTSS_TCI_SPHEREMAP
    }

type D3DUSAGE = DWORD
#{enum D3DUSAGE,
    , d3DUSAGE_AUTOGENMIPMAP        = D3DUSAGE_AUTOGENMIPMAP
    , d3DUSAGE_DEPTHSTENCIL         = D3DUSAGE_DEPTHSTENCIL
    , d3DUSAGE_DMAP                 = D3DUSAGE_DMAP
    , d3DUSAGE_DONOTCLIP            = D3DUSAGE_DONOTCLIP
    , d3DUSAGE_DYNAMIC              = D3DUSAGE_DYNAMIC
    , d3DUSAGE_NPATCHES             = D3DUSAGE_NPATCHES
    , d3DUSAGE_POINTS               = D3DUSAGE_POINTS
    , d3DUSAGE_RENDERTARGET         = D3DUSAGE_RENDERTARGET
    , d3DUSAGE_RTPATCHES            = D3DUSAGE_RTPATCHES
    , d3DUSAGE_SOFTWAREPROCESSING   = D3DUSAGE_SOFTWAREPROCESSING
    , d3DUSAGE_WRITEONLY            = D3DUSAGE_WRITEONLY
    }

type D3DUSAGE_QUERY = DWORD
#{enum D3DUSAGE_QUERY,
    , d3DUSAGE_QUERY_FILTER                     = D3DUSAGE_QUERY_FILTER
    , d3DUSAGE_QUERY_LEGACYBUMPMAP              = D3DUSAGE_QUERY_LEGACYBUMPMAP
    , d3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING   = D3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING
    , d3DUSAGE_QUERY_SRGBREAD                   = D3DUSAGE_QUERY_SRGBREAD
    , d3DUSAGE_QUERY_SRGBWRITE                  = D3DUSAGE_QUERY_SRGBWRITE
    , d3DUSAGE_QUERY_VERTEXTEXTURE              = D3DUSAGE_QUERY_VERTEXTEXTURE
    }
    -- , d3DUSAGE_QUERY_WRAPANDMIP                 = D3DUSAGE_QUERY_WRAPANDMIP


type D3DVERTEXTEXTURESAMPLER = DWORD
#{enum D3DVERTEXTEXTURESAMPLER,
    , d3DVERTEXTEXTURESAMPLER0  = D3DVERTEXTEXTURESAMPLER0
    , d3DVERTEXTEXTURESAMPLER1  = D3DVERTEXTEXTURESAMPLER1
    , d3DVERTEXTEXTURESAMPLER2  = D3DVERTEXTEXTURESAMPLER2
    , d3DVERTEXTEXTURESAMPLER3  = D3DVERTEXTEXTURESAMPLER3
    , d3DDMAPSAMPLER            = D3DDMAPSAMPLER
    }

type D3DVS20CAPS = DWORD
#{enum D3DVS20CAPS,
    , d3DVS20CAPS_PREDICATION               = D3DVS20CAPS_PREDICATION
    , d3DVS20_MAX_DYNAMICFLOWCONTROLDEPTH   = D3DVS20_MAX_DYNAMICFLOWCONTROLDEPTH
    , d3DVS20_MIN_DYNAMICFLOWCONTROLDEPTH   = D3DVS20_MIN_DYNAMICFLOWCONTROLDEPTH
    , d3DVS20_MAX_NUMTEMPS                  = D3DVS20_MAX_NUMTEMPS
    , d3DVS20_MIN_NUMTEMPS                  = D3DVS20_MIN_NUMTEMPS
    , d3DVS20_MAX_STATICFLOWCONTROLDEPTH    = D3DVS20_MAX_STATICFLOWCONTROLDEPTH
    , d3DVS20_MIN_STATICFLOWCONTROLDEPTH    = D3DVS20_MIN_STATICFLOWCONTROLDEPTH
    }

type D3DVTXPCAPS = DWORD
#{enum D3DVTXPCAPS,
    , d3DVTXPCAPS_DIRECTIONALLIGHTS         = D3DVTXPCAPS_DIRECTIONALLIGHTS
    , d3DVTXPCAPS_LOCALVIEWER               = D3DVTXPCAPS_LOCALVIEWER
    , d3DVTXPCAPS_MATERIALSOURCE7           = D3DVTXPCAPS_MATERIALSOURCE7
    , d3DVTXPCAPS_NO_TEXGEN_NONLOCALVIEWER  = D3DVTXPCAPS_NO_TEXGEN_NONLOCALVIEWER
    , d3DVTXPCAPS_POSITIONALLIGHTS          = D3DVTXPCAPS_POSITIONALLIGHTS
    , d3DVTXPCAPS_TEXGEN                    = D3DVTXPCAPS_TEXGEN
    , d3DVTXPCAPS_TEXGEN_SPHEREMAP          = D3DVTXPCAPS_TEXGEN_SPHEREMAP
    , d3DVTXPCAPS_TWEENING                  = D3DVTXPCAPS_TWEENING
    }
    
    


